// ---------------------------------------------------------------------------------------
#ifndef _ANALOG_H
#define _ANALOG_H


// Positionen im vars-Speicher

//  |     INT0    |    INT1     |     INT2    |     INT3    |     INT4    |    INT5     |
//  |             |             |             |             |             |             |        
//  |     AN5     |             |     AN6     |             |     AN7     |             |
//  |      |      |KTY5_1|KTY5_0|      |      |KTY5_1|KTY5_0|      |      |KTY5_1|KTY5_0|
//  |      |      |      |      |      |      |      |      |      |      |      |      |      
//  |Byte0 |Byte1 |Byte2 |Byte3 |Byte4 |Byte5 |Byte6 |Byte7 |Byte8 |Byte9 |Byte10|Byte11|
//

extern  int ReadADC(unsigned char adc_input);
extern void ADC_Init(void);
extern void GetTemperature(void);
#endif

