/*
AUTH server
notwendig fuer SMTP (die meisten SMTP-Server fragen beim AUTH nach, wer den
entsprechenden absender-port benutzt). AUTH ist imho absoluter unsinn und nur
in netzen halbwegs sinnvoll, wo user keine moeglichkeit haben, selbst den
AUTH server zu beeinflussen (rechenzentren).

Copyright (C) 2005 Mark Haemmerling <avr.webserver@markh.de>
*/

#include "main.h"
#include "auth.h"

PROGMEM char IDENT_ANSWER[] = "64, 25 : USERID : AVRserver\r\n";

void auth(char* buffer, int *bufferlen) {
	unsigned int tcpdata;
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	//Verwaltung Stackpointer
	unsigned char a;//Stack Speichplatz Default (0..10)

	if (TCP_Stack(buffer,bufferlen,&a) == 1) return; //keine Daten fr Anwendung
	tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
	
	// !> ende?? meldet sich der client bei uns ab? handeln!
	
	//berprft daten
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1) {
		unsigned char i;

		for (i = 0; i < 64; i++) {
			if ((buffer[tcpdata+i] == '\r') || (buffer[tcpdata+i] == '\r')) break;
		}
		buffer[tcpdata+i] = '\0';

		printf("Ident: [%s]\n", buffer+tcpdata);

		tcp_store(buffer);	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;

		// !> hier tcp-stack durchsuchen nach der remote-portnr. und entspr. antworten
		i = sprintf_P(buffer+tcpdata, IDENT_ANSWER);
		
		TCP_New_Packtlen(buffer, bufferlen, tcpdata + i);
		tcp_make(buffer);			
		Write_Ethernet_Frame (buffer,*bufferlen);	
	}
}
